#ifndef __EMU_WRAPPER_H
#define __EMU_WRAPPER_H

/* wrapper for 2.2 kernel */

#include <linux/wrapper.h>

#define vma_get_pgoff(v)	vma_get_offset(v)
#define wait_queue_head_t	struct wait_queue *
#define DECLARE_WAITQUEUE(a, b)	struct wait_queue a = {b, NULL};
#define init_waitqueue_head(a)	init_waitqueue(a)

#define init_MUTEX(a)		*(a) = MUTEX

#define UP_INODE_SEM(a)		up(a)
#define DOWN_INODE_SEM(a)	down(a)

#define GET_INODE_STRUCT()	struct inode *inode = file->f_dentry->d_inode

#define tasklet_hi_schedule(t)	queue_task((t), &tq_immediate); \
				mark_bh(IMMEDIATE_BH)

#define tasklet_init(t,f,d)	(t)->next = NULL; \
				(t)->sync = 0; \
				(t)->routine = (void (*)(void *))(f); \
				(t)->data = (void *)(d)

#define tasklet_struct		tq_struct 

#define tasklet_unlock_wait(t)	while (test_bit(0, &(t)->sync)) { }

struct pci_device_id {
        unsigned int vendor, device;
        unsigned int subvendor, subdevice;
        unsigned int class, class_mask;
        unsigned long driver_data;
};

#define PCI_ANY_ID (~0)

#define MODULE_DEVICE_TABLE(type,name)

#define pci_enable_device(dev) 1 

#define pci_dma_supported(dev, mask) 0

struct pci_driver {
        struct list_head node;
        char *name;
        const struct pci_device_id *id_table;
        int (*probe)(struct pci_dev *dev, const struct pci_device_id *id);
        void (*remove)(struct pci_dev *dev);
        void (*suspend)(struct pci_dev *dev);
        void (*resume)(struct pci_dev *dev);
};

static __inline__ void list_add_tail(struct list_head *new, struct list_head *head)
{
        __list_add(new, head->prev, head);
}

#define list_for_each(pos, head) \
        for (pos = (head)->next; pos != (head); pos = pos->next)

#define __exit

#ifndef MODULE
#define module_init(x)		int init_emu10k1(void) { return x(); }	
#define module_exit(x)
#else
#define module_init(x)		int init_module(void) { return x(); }
#define module_exit(x)		void cleanup_module(void) { x(); }
#endif

#ifdef CONFIG_HOTPLUG
#define __devinit
#define __devinitdata
#define __devexit
#else
#define __devinit __init
#define __devinitdata __initdata
#define __devexit __exit
#endif

#endif
